{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Class.TROOT.Interface where


import Data.Word
import Foreign.ForeignPtr
import HROOT.TypeCast

import HROOT.Class.TROOT.RawType
import HROOT.Class.TSeqCollection.RawType
import HROOT.Class.TCollection.RawType
import HROOT.Class.TDirectory.Interface


class (ITDirectory a) => ITROOT a where

instance Existable TROOT where
  data Exist TROOT = forall a. (FPtr a, ITROOT a) => ETROOT a

upcastTROOT :: (FPtr a, ITROOT a) => a -> TROOT
upcastTROOT h = let fh = get_fptr h
                    fh2 :: ForeignPtr RawTROOT = castForeignPtr fh
                in cast_fptr_to_obj fh2
