#ifdef __cplusplus
extern "C" { 
#endif 

#include "HROOTType.h"

#include "HROOTTDirectory.h"
#include "HROOTTNamed.h"
#include "HROOTTObject.h"
#include "HROOTDeletable.h"

#undef ROOT_TROOT_DECLARATIONVIRT
#define ROOT_TROOT_DECLARATIONVIRT(Type) \


#undef ROOT_TROOT_DECLARATIONNONVIRT
#define ROOT_TROOT_DECLARATIONNONVIRT(Type) \
TSeqCollection_p Type ## _tROOTGetListOfColors ( Type ## _p p ); \
TCollection_p Type ## _tROOTGetListOfTypes ( Type ## _p p, int load ); \
TCollection_p Type ## _tROOTGetListOfGlobals ( Type ## _p p, int load ); \
TCollection_p Type ## _tROOTGetListOfGlobalFunctions ( Type ## _p p, int load ); \
TSeqCollection_p Type ## _tROOTGetListOfClosedObjects ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfFiles ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfMappedFiles ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfSockets ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfCanvases ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfStyles ( Type ## _p p ); \
TCollection_p Type ## _tROOTGetListOfFunctions ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfGeometries ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfBrowsers ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfSpecials ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfTasks ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfCleanups ( Type ## _p p ); \
TSeqCollection_p Type ## _tROOTGetListOfStreamerInfo ( Type ## _p p ); \
int  Type ## _tROOTDecreaseDirLevel (  ); \
int  Type ## _tROOTGetDirLevel (  ); \
const char * Type ## _tROOTGetMacroPath (  ); \
void Type ## _tROOTSetMacroPath ( const char * newpath ); \
int  Type ## _tROOTIncreaseDirLevel (  ); \
void Type ## _tROOTIndentLevel (  ); \
int Type ## _tROOTInitialized (  ); \
int Type ## _tROOTMemCheck (  ); \
void Type ## _tROOTSetDirLevel ( int  level ); \
int  Type ## _tROOTConvertVersionCode2Int ( int  code ); \
int  Type ## _tROOTConvertVersionInt2Code ( int  v ); \
int  Type ## _tROOTRootVersionCode (  )

#undef ROOT_TROOT_DEFINITIONVIRT
#define ROOT_TROOT_DEFINITIONVIRT(Type)\


#undef ROOT_TROOT_DEFINITIONNONVIRT
#define ROOT_TROOT_DEFINITIONNONVIRT(Type)\
TSeqCollection_p Type ## _tROOTGetListOfColors ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfColors());\
}\
TCollection_p Type ## _tROOTGetListOfTypes ( Type ## _p p, int load )\
{\
return to_nonconst<TCollection_t,TCollection>((TCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfTypes(load));\
}\
TCollection_p Type ## _tROOTGetListOfGlobals ( Type ## _p p, int load )\
{\
return to_nonconst<TCollection_t,TCollection>((TCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfGlobals(load));\
}\
TCollection_p Type ## _tROOTGetListOfGlobalFunctions ( Type ## _p p, int load )\
{\
return to_nonconst<TCollection_t,TCollection>((TCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfGlobalFunctions(load));\
}\
TSeqCollection_p Type ## _tROOTGetListOfClosedObjects ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfClosedObjects());\
}\
TSeqCollection_p Type ## _tROOTGetListOfFiles ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfFiles());\
}\
TSeqCollection_p Type ## _tROOTGetListOfMappedFiles ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfMappedFiles());\
}\
TSeqCollection_p Type ## _tROOTGetListOfSockets ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfSockets());\
}\
TSeqCollection_p Type ## _tROOTGetListOfCanvases ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfCanvases());\
}\
TSeqCollection_p Type ## _tROOTGetListOfStyles ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfStyles());\
}\
TCollection_p Type ## _tROOTGetListOfFunctions ( Type ## _p p )\
{\
return to_nonconst<TCollection_t,TCollection>((TCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfFunctions());\
}\
TSeqCollection_p Type ## _tROOTGetListOfGeometries ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfGeometries());\
}\
TSeqCollection_p Type ## _tROOTGetListOfBrowsers ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfBrowsers());\
}\
TSeqCollection_p Type ## _tROOTGetListOfSpecials ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfSpecials());\
}\
TSeqCollection_p Type ## _tROOTGetListOfTasks ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfTasks());\
}\
TSeqCollection_p Type ## _tROOTGetListOfCleanups ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfCleanups());\
}\
TSeqCollection_p Type ## _tROOTGetListOfStreamerInfo ( Type ## _p p )\
{\
return to_nonconst<TSeqCollection_t,TSeqCollection>((TSeqCollection*)to_nonconst<Type,Type ## _t>(p)->GetListOfStreamerInfo());\
}\
int  Type ## _tROOTDecreaseDirLevel (  )\
{\
return TROOT::DecreaseDirLevel();\
}\
int  Type ## _tROOTGetDirLevel (  )\
{\
return TROOT::GetDirLevel();\
}\
const char * Type ## _tROOTGetMacroPath (  )\
{\
return TROOT::GetMacroPath();\
}\
void Type ## _tROOTSetMacroPath ( const char * newpath )\
{\
TROOT::SetMacroPath(newpath);\
}\
int  Type ## _tROOTIncreaseDirLevel (  )\
{\
return TROOT::IncreaseDirLevel();\
}\
void Type ## _tROOTIndentLevel (  )\
{\
TROOT::IndentLevel();\
}\
int Type ## _tROOTInitialized (  )\
{\
return TROOT::Initialized();\
}\
int Type ## _tROOTMemCheck (  )\
{\
return TROOT::MemCheck();\
}\
void Type ## _tROOTSetDirLevel ( int  level )\
{\
TROOT::SetDirLevel(level);\
}\
int  Type ## _tROOTConvertVersionCode2Int ( int  code )\
{\
return TROOT::ConvertVersionCode2Int(code);\
}\
int  Type ## _tROOTConvertVersionInt2Code ( int  v )\
{\
return TROOT::ConvertVersionInt2Code(v);\
}\
int  Type ## _tROOTRootVersionCode (  )\
{\
return TROOT::RootVersionCode();\
}

ROOT_TDIRECTORY_DECLARATIONVIRT(TROOT);
ROOT_TNAMED_DECLARATIONVIRT(TROOT);
ROOT_TOBJECT_DECLARATIONVIRT(TROOT);
ROOT_DELETABLE_DECLARATIONVIRT(TROOT);


ROOT_TROOT_DECLARATIONVIRT(TROOT);


ROOT_TROOT_DECLARATIONNONVIRT(TROOT);


#ifdef __cplusplus
}
#endif
